Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties	(revision 46)
@@ -125,8 +125,8 @@
 Edit=Edytuj
 EditTooltip=ZmieÅ wÅaÅciwoÅci tego elementu
-Perform=Wykonaj
-PerformTooltip=Wykonaj eksperyment na symulatorze
-PerformAll=Wykonaj wszystkie
-PerformAllTooltip=Wykonaj wszystkie eksperymenty na symulatorze
+Perform=Uruchom
+PerformTooltip=Uruchom eksperyment na symulatorze
+PerformAll=Uruchom wszystkie eksperymenty
+PerformAllTooltip=Uruchom wszystkie eksperymenty na symulatorze
 Upload=PrzeÅlij
 Clear=WyczyÅÄ
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties	(revision 46)
@@ -109,8 +109,8 @@
 Edit=Edit
 EditTooltip=Change properties of this item
-Perform=Perform
-PerformTooltip=Perform the experiment on the simulator
-PerformAll=Perform all
-PerformAllTooltip=Perform all experiments on the simulator
+Perform=Run
+PerformTooltip=Run the experiment on the simulator
+PerformAll=Run all experiments
+PerformAllTooltip=Run all experiments on the simulator
 Upload=Upload
 Clear=Clear
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/views/ExperimentEditor.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/views/ExperimentEditor.mxml	(revision 20)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/views/ExperimentEditor.mxml	(revision 46)
@@ -244,41 +244,9 @@
 	<code:MDICanvas id="mdiCanvas" width="100%" height="100%" backgroundColor="#FFFFFF" backgroundAlpha="0">
 		<mx:VBox paddingLeft="64" width="100%">
-			<mx:VBox width="100%">
-				<mx:DataGrid dataProvider="{experiments}" rowHeight="35" id="experimentsDG" width="1168" >
-					<mx:columns>
-						<mx:DataGridColumn dataField="name" headerText="{resourceManager.getString('ExperimentEditor', 'Name')}"/>
-						<mx:DataGridColumn dataField="runs" headerText="{resourceManager.getString('ExperimentEditor', 'Runs')}"/>
-						<mx:DataGridColumn dataField="global" headerText="{resourceManager.getString('ExperimentEditor', 'GlobalPlugin')}"/>
-						<mx:DataGridColumn dataField="local" headerText="{resourceManager.getString('ExperimentEditor', 'LocalPlugin')}"/>
-						<mx:DataGridColumn dataField="exec" headerText="{resourceManager.getString('ExperimentEditor', 'ExecutionPlugin')}"/>
-						<mx:DataGridColumn dataField="workload" headerText="{resourceManager.getString('ExperimentEditor', 'Workload')}"/>
-						<mx:DataGridColumn dataField="topology" headerText="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
-						<mx:DataGridColumn dataField="resources" headerText="{resourceManager.getString('ExperimentEditor', 'ResourceDescription')}"/>
-						<mx:DataGridColumn headerText="{resourceManager.getString('ExperimentEditor', 'Actions')}" width="200">
-							<mx:itemRenderer>
-								<mx:Component>
-									<mx:HBox paddingLeft="4">
-										<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Perform')}" toolTip="{resourceManager.getString('ExperimentEditor', 'PerformTooltip')}" click="outerDocument.performExperiment()" height="30" paddingLeft="8"/>
-										<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Edit')}" toolTip="{resourceManager.getString('ExperimentEditor', 'EditTooltip')}" click="outerDocument.editExperiment()" height="30"/>
-										<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeItem(outerDocument.experimentsDG)" height="30"/>
-									</mx:HBox>
-								</mx:Component>
-							</mx:itemRenderer>
-						</mx:DataGridColumn>
-					</mx:columns>
-				</mx:DataGrid>
-				<mx:HBox>
-					<!--<mx:Button id="newExperiment" click="createNewExperiment()" toolTip="{resourceManager.getString('ExperimentEditor', 'CreateNewExperiment')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'New')}"/>-->
-					<mx:Button id="performExperiments" click="performAllExperiments()" toolTip="{resourceManager.getString('ExperimentEditor', 'PerformAllTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'PerformAll')}"/>
-					<mx:HBox>
-						<mx:Label text="{resourceManager.getString('ExperimentEditor', 'Metaname')}"/>
-						<components:QuickTooltipImage height="16" width="16"
-								  toolTip="{resourceManager.getString('Help', 'ExperimentMetaname')}"
-								  source="assets/icon/HelpIcon.png"/>
-						<mx:TextInput id="experimentMetaname" width="250" restrict="0-9a-zA-Z" />
-					</mx:HBox>
-				</mx:HBox>
-			</mx:VBox>
 			<mx:HBox width="100%" height="100%">
+				<mx:TabNavigator width="650" height="335">
+					<experiment:ExperimentPropertiesPanel id="experimentProperties" paddingLeft="5"/>
+					<experiment:FileManager paddingLeft="5"/>
+				</mx:TabNavigator>
 				<mx:TabNavigator height="335" width="510">
 					<mx:HBox label="{resourceManager.getString('ExperimentEditor', 'Workspace')}" paddingLeft="5">
@@ -308,28 +276,4 @@
 						</mx:VBox>
 						<mx:VBox>
-							<mx:Label text="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
-							<mx:DataGrid dataProvider="{workspaceTopologiesFileList}" rowHeight="35" id="topologyFilesDG" >
-								<mx:columns>
-									<mx:DataGridColumn dataField="fileName" headerText="Name"/>
-									<mx:DataGridColumn headerText="{resourceManager.getString('ExperimentEditor', 'Actions')}" width="55">
-										<mx:itemRenderer>
-											<mx:Component>
-												<mx:HBox paddingLeft="4">
-													<!--
-													<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Load')}" toolTip="{resourceManager.getString('ExperimentEditor', 'LoadTooltip')}" click="outerDocument.loadTopology()" height="30" paddingLeft="8"/>
-													-->
-													<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeItem(outerDocument.topologyFilesDG)" height="30"/>
-												</mx:HBox>
-											</mx:Component>
-										</mx:itemRenderer>
-									</mx:DataGridColumn>
-								</mx:columns>
-							</mx:DataGrid>
-							<mx:HBox>
-								<mx:Button id="newTopologyFile" click="addNewTopologyFile()" toolTip="{resourceManager.getString('ExperimentEditor', 'AddFile')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Upload')}"/>
-								<mx:Button click="clear(topologyFilesDG)" toolTip="{resourceManager.getString('ExperimentEditor', 'ClearFiles')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Clear')}"/>
-							</mx:HBox>
-						</mx:VBox>
-						<mx:VBox>
 							<mx:Label text="{resourceManager.getString('ExperimentEditor', 'ResourceDescription')}"/>
 							<!--<mx:DataGrid dataProvider="{resourceFiles}" rowHeight="35" id="resourceFilesDG" >-->
@@ -356,11 +300,68 @@
 							</mx:HBox>
 						</mx:VBox>
+						<mx:VBox>
+							<mx:Label text="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
+							<mx:DataGrid dataProvider="{workspaceTopologiesFileList}" rowHeight="35" id="topologyFilesDG" >
+								<mx:columns>
+									<mx:DataGridColumn dataField="fileName" headerText="Name"/>
+									<mx:DataGridColumn headerText="{resourceManager.getString('ExperimentEditor', 'Actions')}" width="55">
+										<mx:itemRenderer>
+											<mx:Component>
+												<mx:HBox paddingLeft="4">
+													<!--
+													<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Load')}" toolTip="{resourceManager.getString('ExperimentEditor', 'LoadTooltip')}" click="outerDocument.loadTopology()" height="30" paddingLeft="8"/>
+													-->
+													<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeItem(outerDocument.topologyFilesDG)" height="30"/>
+												</mx:HBox>
+											</mx:Component>
+										</mx:itemRenderer>
+									</mx:DataGridColumn>
+								</mx:columns>
+							</mx:DataGrid>
+							<mx:HBox>
+								<mx:Button id="newTopologyFile" click="addNewTopologyFile()" toolTip="{resourceManager.getString('ExperimentEditor', 'AddFile')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Upload')}"/>
+								<mx:Button click="clear(topologyFilesDG)" toolTip="{resourceManager.getString('ExperimentEditor', 'ClearFiles')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Clear')}"/>
+							</mx:HBox>
+						</mx:VBox>
 					</mx:HBox>
 				</mx:TabNavigator>
-				<mx:TabNavigator width="650" height="335">
-					<experiment:ExperimentPropertiesPanel id="experimentProperties" paddingLeft="5"/>
-					<experiment:FileManager paddingLeft="5"/>
-				</mx:TabNavigator>
 			</mx:HBox>
+			
+			<mx:VBox width="100%">
+				<mx:DataGrid dataProvider="{experiments}" rowHeight="35" id="experimentsDG" width="1168" >
+					<mx:columns>
+						<mx:DataGridColumn dataField="name" headerText="{resourceManager.getString('ExperimentEditor', 'Name')}"/>
+						<mx:DataGridColumn dataField="runs" headerText="{resourceManager.getString('ExperimentEditor', 'Runs')}"/>
+						<mx:DataGridColumn dataField="global" headerText="{resourceManager.getString('ExperimentEditor', 'GlobalPlugin')}"/>
+						<mx:DataGridColumn dataField="local" headerText="{resourceManager.getString('ExperimentEditor', 'LocalPlugin')}"/>
+						<mx:DataGridColumn dataField="exec" headerText="{resourceManager.getString('ExperimentEditor', 'ExecutionPlugin')}"/>
+						<mx:DataGridColumn dataField="workload" headerText="{resourceManager.getString('ExperimentEditor', 'Workload')}"/>
+						<mx:DataGridColumn dataField="topology" headerText="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
+						<mx:DataGridColumn dataField="resources" headerText="{resourceManager.getString('ExperimentEditor', 'ResourceDescription')}"/>
+						<mx:DataGridColumn headerText="{resourceManager.getString('ExperimentEditor', 'Actions')}" width="200">
+							<mx:itemRenderer>
+								<mx:Component>
+									<mx:HBox paddingLeft="4">
+										<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Perform')}" toolTip="{resourceManager.getString('ExperimentEditor', 'PerformTooltip')}" click="outerDocument.performExperiment()" height="30" paddingLeft="8"/>
+										<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Edit')}" toolTip="{resourceManager.getString('ExperimentEditor', 'EditTooltip')}" click="outerDocument.editExperiment()" height="30"/>
+										<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeItem(outerDocument.experimentsDG)" height="30"/>
+									</mx:HBox>
+								</mx:Component>
+							</mx:itemRenderer>
+						</mx:DataGridColumn>
+					</mx:columns>
+				</mx:DataGrid>
+				<mx:HBox width="1168">
+					<mx:Spacer width="100%"/>
+					<mx:HBox>
+						<mx:Label text="{resourceManager.getString('ExperimentEditor', 'Metaname')}"/>
+						<components:QuickTooltipImage height="16" width="16"
+													  toolTip="{resourceManager.getString('Help', 'ExperimentMetaname')}"
+													  source="assets/icon/HelpIcon.png"/>
+						<mx:ComboBox id="experimentMetaname" width="150" restrict="0-9a-zA-Z" dataProvider="{parentApplication.gsSimStudioModel.metaexperimentList}" editable="true" />
+					</mx:HBox>
+					<mx:Button id="performExperiments" click="performAllExperiments()" toolTip="{resourceManager.getString('ExperimentEditor', 'PerformAllTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'PerformAll')}"/>
+				</mx:HBox>
+			</mx:VBox>
 			
 			<mx:VBox visible="{showDebug}" includeInLayout="{showDebug}">
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml	(revision 46)
@@ -180,26 +180,4 @@
 				</mx:VBox>
 				<mx:VBox>
-					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
-					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.topologiesFileLocationItemList}" rowHeight="35" id="topologyFilesDG" >
-						<mx:columns>
-							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
-							<mx:DataGridColumn headerText="{resourceManager.getString('ExperimentEditor', 'Actions')}" width="105">
-								<mx:itemRenderer>
-									<mx:Component>
-										<mx:HBox paddingLeft="4">
-											<!--
-											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Load')}" toolTip="{resourceManager.getString('ExperimentEditor', 'LoadTooltip')}" click="outerDocument.loadTopology()" height="30" paddingLeft="8"/>
-											-->
-											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Add')}" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" click="outerDocument.addItemToWorkspace(outerDocument.topologyFilesDG, parentApplication.experimentEditor.workspaceTopologiesFileList)" height="30"/>
-											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeFileItem(outerDocument.topologyFilesDG)" height="30"/>
-										</mx:HBox>
-									</mx:Component>
-								</mx:itemRenderer>
-							</mx:DataGridColumn>
-						</mx:columns>
-					</mx:DataGrid>
-					<mx:Button id="newTopologyFile" click="addNewTopologyFile()" toolTip="{resourceManager.getString('ExperimentEditor', 'AddFile')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Upload')}"/>
-				</mx:VBox>
-				<mx:VBox>
 					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'ResourceDescription')}"/>
 					<!--<mx:DataGrid dataProvider="{resourceFiles}" rowHeight="35" id="resourceFilesDG" >-->
@@ -224,4 +202,26 @@
 					<mx:Button id="newResourceFile" click="addNewResourceFile()" toolTip="{resourceManager.getString('ExperimentEditor', 'AddFile')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Upload')}"/>
 				</mx:VBox>
+				<mx:VBox>
+					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
+					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.topologiesFileLocationItemList}" rowHeight="35" id="topologyFilesDG" >
+						<mx:columns>
+							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
+							<mx:DataGridColumn headerText="{resourceManager.getString('ExperimentEditor', 'Actions')}" width="105">
+								<mx:itemRenderer>
+									<mx:Component>
+										<mx:HBox paddingLeft="4">
+											<!--
+											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Load')}" toolTip="{resourceManager.getString('ExperimentEditor', 'LoadTooltip')}" click="outerDocument.loadTopology()" height="30" paddingLeft="8"/>
+											-->
+											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Add')}" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" click="outerDocument.addItemToWorkspace(outerDocument.topologyFilesDG, parentApplication.experimentEditor.workspaceTopologiesFileList)" height="30"/>
+											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeFileItem(outerDocument.topologyFilesDG)" height="30"/>
+										</mx:HBox>
+									</mx:Component>
+								</mx:itemRenderer>
+							</mx:DataGridColumn>
+						</mx:columns>
+					</mx:DataGrid>
+					<mx:Button id="newTopologyFile" click="addNewTopologyFile()" toolTip="{resourceManager.getString('ExperimentEditor', 'AddFile')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Upload')}"/>
+				</mx:VBox>
 			</mx:HBox>
 			<mx:VBox visible="{showDebug}" includeInLayout="{showDebug}">
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/ExperimentPropertiesPanel.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/ExperimentPropertiesPanel.mxml	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/ExperimentPropertiesPanel.mxml	(revision 46)
@@ -15,4 +15,5 @@
 			import mx.core.IUIComponent;
 			import mx.events.CloseEvent;
+			import mx.events.FlexEvent;
 			import mx.events.ListEvent;
 			
@@ -226,5 +227,5 @@
 
 
-			protected function resourceDescriptionFile_changeHandler(event:ListEvent):void
+			protected function resourceDescriptionFile_changeHandler(event:Event):void
 			{
 				for (var i : int = 0; i < parentApplication.gsSimStudioModel.resourcesFileLocationItemList.length; i++)
@@ -240,5 +241,5 @@
 
 
-			protected function networkTopologyFile_changeHandler(event:ListEvent):void
+			protected function networkTopologyFile_changeHandler(event:Event):void
 			{
 				if (networkTopologyFile.text == null)
@@ -259,5 +260,5 @@
 
 
-			protected function workloadFile_changeHandler(event:ListEvent):void
+			protected function workloadFile_changeHandler(event:Event):void
 			{
 				for (var i : int = 0; i < parentApplication.gsSimStudioModel.workloadFileLocationItemList.length; i++)
@@ -358,6 +359,6 @@
 							 toolTip="{resourceManager.getString('ExperimentEditor', 'ExecutionTimeEstimationTooltip')}"/>
 			</mx:VBox>
-			<mx:VBox label="{resourceManager.getString('ExperimentEditor', 'Files')}">
-				<mx:HBox>
+			<mx:VBox label="{resourceManager.getString('ExperimentEditor', 'Files')}" width="350">
+				<mx:HBox width="100%">
 					<mx:HBox>
 						<mx:Label text="{resourceManager.getString('ExperimentEditor', 'Workload')}"/>
@@ -366,4 +367,5 @@
 								  source="assets/icon/HelpIcon.png"/>
 					</mx:HBox>
+					<mx:Spacer width="100%"/>
 					<mx:CheckBox id="workloadSelectedCB" label="{resourceManager.getString('ExperimentEditor', 'UseSelectedFiles')}" height="16"
 								 enabled="{!topologySelectedCB.selected &amp;&amp; !resourceSelectedCB.selected}"/>
@@ -375,28 +377,9 @@
 					<mx:ComboBox id="workloadFile" labelField="fileName" dataProvider="{parentApplication.experimentEditor.workspaceWorkloadsFileList}" width="250"
 								 toolTip="{resourceManager.getString('ExperimentEditor', 'WorkloadTooltip')}" enabled="{!workloadSelectedCB.selected}"
-								 change="workloadFile_changeHandler(event)"/>
+								 change="workloadFile_changeHandler(event)" dataChange="workloadFile_changeHandler(event)"/>
 					<components:QuickTooltipImage height="16" width="16" id="workloadMissingImage" visible="false"
 												  source="assets/deleteButton.png"/>
 				</mx:HBox>
-				<mx:HBox>
-					<mx:HBox>
-						<mx:CheckBox id="topologyCB" label="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}" height="16"
-									 change="topologyCB_changeHandler(event)"/>
-						<components:QuickTooltipImage height="16" width="16"
-								  toolTip="{resourceManager.getString('Help', 'NetworkTopology')}"
-								  source="assets/icon/HelpIcon.png"/>
-					</mx:HBox>
-					<mx:CheckBox id="topologySelectedCB" label="{resourceManager.getString('ExperimentEditor', 'UseSelectedFiles')}"
-								 enabled="{topologyCB.selected &amp;&amp; !resourceSelectedCB.selected &amp;&amp; !workloadSelectedCB.selected}" height="16"/>
-				</mx:HBox>
-				<mx:HBox>
-					<mx:ComboBox id="networkTopologyFile" labelField="fileName" dataProvider="{parentApplication.experimentEditor.workspaceTopologiesFileList}" width="250"
-							 toolTip="{resourceManager.getString('ExperimentEditor', 'NetworkTopologyTooltip')}"
-							 enabled="{topologyCB.selected &amp;&amp; !topologySelectedCB.selected}"
-							 change="networkTopologyFile_changeHandler(event)"/>
-					<components:QuickTooltipImage height="16" width="16" id="topologyMissingImage" visible="false"
-											  source="assets/deleteButton.png"/>
-				</mx:HBox>
-				<mx:HBox>
+				<mx:HBox width="100%">
 					<mx:HBox>
 						<mx:Label text="{resourceManager.getString('ExperimentEditor', 'ResourceDescription')}"/>
@@ -405,19 +388,42 @@
 								  source="assets/icon/HelpIcon.png"/>
 					</mx:HBox>
+					<mx:Spacer width="100%"/>
 					<mx:CheckBox id="resourceSelectedCB" label="{resourceManager.getString('ExperimentEditor', 'UseSelectedFiles')}" height="16"
 								 enabled="{!topologySelectedCB.selected &amp;&amp; !workloadSelectedCB.selected}"/>
 				</mx:HBox>
-				
 				<mx:HBox>
 					<mx:ComboBox id="resourceDescriptionFile" labelField="fileName" dataProvider="{parentApplication.experimentEditor.workspaceResourcesFileList}" width="250"
 								 toolTip="{resourceManager.getString('ExperimentEditor', 'ResourceDescriptionTooltip')}"
-								 enabled="{!resourceSelectedCB.selected}" change="resourceDescriptionFile_changeHandler(event)"/>
+								 enabled="{!resourceSelectedCB.selected}" change="resourceDescriptionFile_changeHandler(event)"
+								 dataChange="resourceDescriptionFile_changeHandler(event)"/>
 					<components:QuickTooltipImage height="16" width="16" id="resourceMissingImage" visible="false"
 												  source="assets/deleteButton.png"/>
 				</mx:HBox>
-				<mx:HBox>
-					<mx:Button id="addExperiment" click="createExperiment();" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Add')}"/>
+				<mx:HBox width="100%">
+					<mx:HBox>
+						<mx:CheckBox id="topologyCB" label="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}" height="16"
+									 change="topologyCB_changeHandler(event)"/>
+						<components:QuickTooltipImage height="16" width="16"
+													  toolTip="{resourceManager.getString('Help', 'NetworkTopology')}"
+													  source="assets/icon/HelpIcon.png"/>
+					</mx:HBox>
+					<mx:Spacer width="100%"/>
+					<mx:CheckBox id="topologySelectedCB" label="{resourceManager.getString('ExperimentEditor', 'UseSelectedFiles')}"
+								 enabled="{topologyCB.selected &amp;&amp; !resourceSelectedCB.selected &amp;&amp; !workloadSelectedCB.selected}" height="16"/>
+				</mx:HBox>
+				<mx:HBox>
+					<mx:ComboBox id="networkTopologyFile" labelField="fileName" dataProvider="{parentApplication.experimentEditor.workspaceTopologiesFileList}" width="250"
+								 toolTip="{resourceManager.getString('ExperimentEditor', 'NetworkTopologyTooltip')}"
+								 enabled="{topologyCB.selected &amp;&amp; !topologySelectedCB.selected}"
+								 change="networkTopologyFile_changeHandler(event)" dataChange="networkTopologyFile_changeHandler(event)"/>
+					<components:QuickTooltipImage height="16" width="16" id="topologyMissingImage" visible="false"
+												  source="assets/deleteButton.png"/>
 				</mx:HBox>
 			</mx:VBox>
+		</mx:HBox>
+		<mx:HBox width="100%">
+			<mx:Spacer width="50%"/>
+			<mx:Button id="addExperiment" click="createExperiment();" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Add')}"/>
+			<mx:Spacer width="50%"/>
 		</mx:HBox>
 	</mx:VBox>
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 46)
@@ -7,5 +7,5 @@
 	xmlns:fx="http://ns.adobe.com/mxml/2009"  
 	width="100%" creationComplete="init()"
-	height="100%" xmlns:charts="com.iwobanas.charts.*" xmlns:data="gssim.gssimstudio.editor.charting.data.*" xmlns:charts1="gssim.gssimstudio.editor.charts.*" 
+	height="100%" xmlns:charts="com.iwobanas.charts.*" xmlns:data="gssim.gssimstudio.editor.charting.data.*" xmlns:charts1="gssim.gssimstudio.editor.charts.*" xmlns:components="gssim.gssimstudio.editor.gssim.components.*" 
 >
 	
@@ -17,4 +17,6 @@
 	<fx:Script>
 	    <![CDATA[
+			import com.iwobanas.charts.NumericAxisHelper;
+			
 			import gssim.gssimstudio.editor.script.command.SaveToPNGCommand;
 			import gssim.gssimstudio.editor.script.views.ViewsHelper;
@@ -23,4 +25,6 @@
 			import mx.charts.AxisRenderer;
 			import mx.charts.chartClasses.AxisLabelSet;
+			import mx.charts.chartClasses.ChartBase;
+			import mx.charts.chartClasses.IAxis;
 			import mx.collections.ArrayCollection;
 			import mx.controls.Alert;
@@ -133,4 +137,82 @@
 			}
 			
+			/**
+			 * Scroll chart content by specified horizontal and vertical distance.
+			 * Scrolling is done by modifying axis minimum and maximum values.
+			 * <p>Note that call to this function takes effect only if ChartScroller 
+			 * is initialized (i.e. <code>series</code> and at least one of <code>hAxis</code> 
+			 * and <code>vAxis</code> are set) and scrolling is enabled
+			 * (horizontalScrollEnabled/verticalScrollEnabled properties are set).</p>
+			 * 
+			 * @param dx distance to scroll horizontally in data coordinates
+			 * @param dy distance to scroll vertically in data coordinates
+			 */
+			/*
+			protected function scrollChart(dx:Number, dy:Number):void
+			{
+				var changed:Boolean = false;
+				
+				if (hAxis && horizontalScrollEnabled)
+				{
+					NumericAxisHelper.setMin(hAxis, NumericAxisHelper.getMin(hAxis) + dx);
+					NumericAxisHelper.setMax(hAxis, NumericAxisHelper.getMax(hAxis) + dx);
+					changed = true;
+				}
+				if (vAxis && verticalScrollEnabled)
+				{
+					NumericAxisHelper.setMin(vAxis, NumericAxisHelper.getMin(vAxis) + dy);
+					NumericAxisHelper.setMax(vAxis, NumericAxisHelper.getMax(vAxis) + dy);
+					changed = true;
+				}
+				
+				if (changed)
+				{
+					processChange();
+				}
+			}*/
+			
+			/**
+			 * Zoom chart content relative to a given point in data coordinates.
+			 * <p>Note that call to this function takes effect only if ChartScroller 
+			 * is initialized (i.e. <code>series</code> and at least one of <code>hAxis</code> 
+			 * and <code>vAxis</code> are set) and zooming is enabled
+			 * (horizontalZoomEnabled/verticalZoomEnabled properties are set).</p>
+			 * 
+			 * @param ralativeTo point in data coordinates
+			 * @param zoom indicate how much the content should be zoomed, 
+			 * if this value is greater than 1 content is zoomed in otherways content is zoomed out.
+			 */
+			protected function zoomChart(chart : AreaChart, ralativeTo:Point, zoom:Number):void
+			{
+				var hAxis : IAxis = chart.horizontalAxis;
+				var vAxis : IAxis = chart.verticalAxis;
+				
+				var dMin:Number; // distance from minimum to relativeTo point in given dimension
+				var dMax:Number; // distance from maximum to relativeTo point in given dimension
+				
+				if (hAxis)
+				{
+					dMin = ralativeTo.x - NumericAxisHelper.getMin(hAxis);
+					dMax = NumericAxisHelper.getMax(hAxis) - ralativeTo.x;
+					
+					NumericAxisHelper.setMin(hAxis, ralativeTo.x - dMin/zoom);
+					NumericAxisHelper.setMax(hAxis, ralativeTo.x + dMax/zoom);
+				}
+				if (vAxis)
+				{
+					dMin = ralativeTo.y - NumericAxisHelper.getMin(vAxis);
+					dMax = NumericAxisHelper.getMax(vAxis) - ralativeTo.y;
+					
+					NumericAxisHelper.setMin(vAxis, ralativeTo.y - dMin/zoom);
+					NumericAxisHelper.setMax(vAxis, ralativeTo.y + dMax/zoom);
+				}
+			}
+			
+			public function zoomMyChart(zoom : Number) : void
+			{
+				var point : Point = new Point();
+				zoomChart(resourceViewer,point,zoom);
+			}
+			
 	    ]]>
 	</fx:Script>
@@ -170,4 +252,9 @@
 			<mx:Button label="{resourceManager.getString('Charts', 'Clone')}" click="cloneChart()"/>
 			<mx:Button label="PNG" click="saveAsPNG();"/>
+			
+			<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" label="{resourceManager.getString('TopologyEditor', 'ZoomIn')}"
+								   autoRepeat="true" buttonDown="zoomMyChart(6/5);" iconUp="assets/icon/ZoomIn.png"/>
+			<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" label="{resourceManager.getString('TopologyEditor', 'ZoomOut')}"
+								   autoRepeat="true" buttonDown="zoomMyChart(5/6);" iconUp="assets/icon/ZoomOut.png"/>
 		</mx:HBox>
 		<mx:VBox width="100%" height="100%" verticalGap="1" id="fullChart">