Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml	(revision 37)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml	(revision 47)
@@ -114,5 +114,5 @@
 									iconUp="assets/icon/OpenFile.png"/>
 		</mx:HBox>
-		<mx:TabNavigator id="view" width="100%" height="100%" top="56" creationPolicy="all" change="view_changeHandler(event)">
+		<mx:TabNavigator id="view" width="100%" height="100%" creationPolicy="all" change="view_changeHandler(event)">
 			<mx:VBox width="100%" height="100%" id="experimentData" label="{resourceManager.getString('ArchiveViewer', 'Basic')}">
 				<archive:ExperimentDataGroup id="basicExperimentData" left="5" top="5"/>
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 46)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 47)
@@ -183,9 +183,6 @@
 			 * if this value is greater than 1 content is zoomed in otherways content is zoomed out.
 			 */
-			protected function zoomChart(chart : AreaChart, ralativeTo:Point, zoom:Number):void
-			{
-				var hAxis : IAxis = chart.horizontalAxis;
-				var vAxis : IAxis = chart.verticalAxis;
-				
+			protected function zoomChart(hAxis : IAxis, vAxis : IAxis, ralativeTo:Point, zoom:Number):void
+			{				
 				var dMin:Number; // distance from minimum to relativeTo point in given dimension
 				var dMax:Number; // distance from maximum to relativeTo point in given dimension
@@ -209,8 +206,16 @@
 			}
 			
-			public function zoomMyChart(zoom : Number) : void
+			public function zoomChartX(zoom : Number) : void
 			{
 				var point : Point = new Point();
-				zoomChart(resourceViewer,point,zoom);
+				point.x = (NumericAxisHelper.getMin(resourceViewer.horizontalAxis) + NumericAxisHelper.getMax(resourceViewer.horizontalAxis))/2;
+				zoomChart(resourceViewer.horizontalAxis, null,point,zoom);
+			}
+			
+			public function zoomChartY(zoom : Number) : void
+			{
+				var point : Point = new Point();
+				point.y = (NumericAxisHelper.getMin(resourceViewer.verticalAxis) + NumericAxisHelper.getMax(resourceViewer.verticalAxis))/2;
+				zoomChart(null, resourceViewer.verticalAxis,point,zoom);
 			}
 			
@@ -252,9 +257,4 @@
 			<mx:Button label="{resourceManager.getString('Charts', 'Clone')}" click="cloneChart()"/>
 			<mx:Button label="PNG" click="saveAsPNG();"/>
-			
-			<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" label="{resourceManager.getString('TopologyEditor', 'ZoomIn')}"
-								   autoRepeat="true" buttonDown="zoomMyChart(6/5);" iconUp="assets/icon/ZoomIn.png"/>
-			<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" label="{resourceManager.getString('TopologyEditor', 'ZoomOut')}"
-								   autoRepeat="true" buttonDown="zoomMyChart(5/6);" iconUp="assets/icon/ZoomOut.png"/>
 		</mx:HBox>
 		<mx:VBox width="100%" height="100%" verticalGap="1" id="fullChart">
@@ -312,3 +312,16 @@
 		</mx:VBox>
 	</mx:VBox>
+	<mx:HBox width="100%" horizontalGap="0" bottom="5">
+		<mx:Spacer width="100%" />
+		<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" width="25" height="25"
+							   autoRepeat="true" buttonDown="zoomChartX(6/5);" iconUp="assets/icon/ZoomIn.png"/>
+		<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" width="25" height="25"
+							   autoRepeat="true" buttonDown="zoomChartX(5/6);" iconUp="assets/icon/ZoomOut.png"/>
+	</mx:HBox>
+	<mx:VBox height="100%" verticalGap="0" top="75">
+		<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" width="25" height="25" 
+							   autoRepeat="true" buttonDown="zoomChartY(6/5);" iconUp="assets/icon/ZoomIn.png"/>
+		<components:IconButton skinClass="gssim.gssimstudio.editor.gssim.skins.IconButtonSkin" width="25" height="25"
+							   autoRepeat="true" buttonDown="zoomChartY(5/6);" iconUp="assets/icon/ZoomOut.png"/>
+	</mx:VBox>
 </mx:Canvas>