Index: trunk/pbs_drmaa/pbs_attrib.h
===================================================================
--- trunk/pbs_drmaa/pbs_attrib.h	(revision 48)
+++ trunk/pbs_drmaa/pbs_attrib.h	(revision 49)
@@ -108,7 +108,7 @@
 	PBSDRMAA_ATTR_HOST,
 	PBSDRMAA_ATTR_NODES,
-	PBSDRMAA_ATTR_SOFTWARE,
 	PBSDRMAA_ATTR_PROCS,
 	PBSDRMAA_ATTR_NCPUS,
+	PBSDRMAA_ATTR_SOFTWARE,
 	PBSDRMAA_ATTR_MAIL_POINTS,
 	PBSDRMAA_ATTR_OUTPUT_PATH,
Index: trunk/pbs_drmaa/log_reader.c
===================================================================
--- trunk/pbs_drmaa/log_reader.c	(revision 48)
+++ trunk/pbs_drmaa/log_reader.c	(revision 49)
@@ -670,4 +670,6 @@
 
 	self->current_offset = ftello(self->fhandle);
+	
+	fsd_log_debug(("Closing log  file (offset=%d)", self->current_offset));  
 
 	fclose(self->fhandle);
@@ -679,4 +681,6 @@
 pbsdrmaa_reopen_log( pbsdrmaa_log_reader_t * self )
 {
+	fsd_log_debug(("Reopening log file: %s (offset=%d)", self->log_path, self->current_offset));  
+
 	if ((self->fhandle = fopen(self->log_path,"r")) == NULL)
 	 {
Index: trunk/pbs_drmaa/submit.c
===================================================================
--- trunk/pbs_drmaa/submit.c	(revision 48)
+++ trunk/pbs_drmaa/submit.c	(revision 49)
@@ -182,5 +182,5 @@
 				char *final_value = NULL;
 
-				if (!nodes_value)
+				if (nodes_value)
 				 {
 					final_value = fsd_asprintf("%s:%s",nodes_value, value);
Index: trunk/pbs_drmaa/pbs_attrib.gperf
===================================================================
--- trunk/pbs_drmaa/pbs_attrib.gperf	(revision 48)
+++ trunk/pbs_drmaa/pbs_attrib.gperf	(revision 49)
@@ -102,6 +102,6 @@
 submit_args, t(PBSDRMAA_ATTR_SUBMIT_ARGS)
 mtime, t(PBSDRMAA_ATTR_MTIME)
-pbsdrmaa.node_properties, t(PBSDRMAA_ATTR_NODE_PROPERTIES)
-pbsdrmaa.custom_resources, t(PBSDRMAA_ATTR_CUSTOM_RESOURCES)
+Resource_List.node_properties, t(PBSDRMAA_ATTR_NODE_PROPERTIES)
+Resource_List.custom_resources, t(PBSDRMAA_ATTR_CUSTOM_RESOURCES)
 %%
 #undef t
@@ -215,6 +215,6 @@
 	{ "submit_args", PBSDRMAA_ATTR_SUBMIT_ARGS, false },
 	{ "mtime", PBSDRMAA_ATTR_MTIME, false },
-	{ "pbsdrmaa.node_properties", PBSDRMAA_ATTR_NODE_PROPERTIES, false },
-	{ "pbsdrmaa.custom_resources", PBSDRMAA_ATTR_CUSTOM_RESOURCES, false },
+	{ "Resource_List.node_properties", PBSDRMAA_ATTR_NODE_PROPERTIES, false }, /* DRMAA extenstions */
+	{ "Resource_List.custom_resources", PBSDRMAA_ATTR_CUSTOM_RESOURCES, false },
 	
 };
Index: trunk/test/example.c
===================================================================
--- trunk/test/example.c	(revision 12)
+++ trunk/test/example.c	(revision 49)
@@ -38,8 +38,8 @@
 
 #define SEND_MAIL     0
-#define WITH_BULK     0
+#define WITH_BULK     1
 #define EXPORT_ENVS   0
 #define DEBUG         1
-#define N_JOBS        1
+#define N_JOBS        8
 
 #define ERR_LEN      DRMAA_ERROR_STRING_BUFFER
@@ -107,7 +107,7 @@
 		printf( "constructing %d\n", i );
 		sprintf( arg, "%d", i );
-		sprintf( job_path, "./test_job" );
+		sprintf( job_path, "/bin/sleep" );
 		argv[0] = job_path;
-		argv[1] = arg;
+		argv[1] = "5";
 		argv[2] = NULL;
 		for( j = 0;  j < 3;  j++ )
@@ -127,5 +127,5 @@
 #endif
 	 }
-
+#if ! WITH_BULK
 	for( i = 0;  i < N_JOBS;  i++ )
 	 {
@@ -145,12 +145,12 @@
 	 }
 
-#if WITH_BULK
-	 {
-		char *argv[] = { "./job", "bulk", "$drmaa_incr_ph$", NULL };
+#else
+	 {
+		char *argv[] = { "/bin/sleep", "5", "$drmaa_incr_ph$", NULL };
 		char *fds[]  = { "b.$drmaa_incr_ph$.stdin", "b.$drmaa_incr_ph$.stdout",
 			"b.$drmaa_incr_ph$.stderr" };
-		bulk_job = construct_job( argv, fds, WD );
-	 }
-	rc = drmaa_run_bulk_jobs( &bulk_job_ids, bulk_job, 1, N_JOBS, 1, err_msg, ERR_LEN );
+		bulk_job = construct_job( argv, fds, "." );
+	 }
+	rc = drmaa_run_bulk_jobs( &bulk_job_ids, bulk_job, 1, N_JOBS, 2, err_msg, ERR_LEN );
 	if( rc )  drmaa_error("drmaa_run_bulk_jobs");
 
@@ -197,11 +197,5 @@
 #endif
 	const char *scalar_attrs[] = {
-		DRMAA_WD            , NULL,
 		DRMAA_REMOTE_COMMAND, NULL,
-		DRMAA_JOB_NAME      , NULL,
-		DRMAA_INPUT_PATH    , NULL,
-		DRMAA_OUTPUT_PATH   , NULL,
-		DRMAA_ERROR_PATH    , NULL,
-                DRMAA_NATIVE_SPECIFICATION, "-l host=eeyore,nodes=1 -W x=FLAGS:ADVRES:usecase.0",
 		NULL                , NULL
 	};
@@ -222,10 +216,5 @@
 	int rc;
 
-	scalar_attrs[ 1] = cwd;
-	scalar_attrs[ 3] = argv[0];
-	scalar_attrs[ 5] = "jobname";
-	scalar_attrs[ 7] = fds[0];
-	scalar_attrs[ 9] = fds[1];
-	scalar_attrs[11] = fds[2];
+	scalar_attrs[ 1] = "/bin/sleep";
 
 	printf( "allocaing template\n" );
Index: trunk/test/Makefile
===================================================================
--- trunk/test/Makefile	(revision 12)
+++ trunk/test/Makefile	(revision 49)
@@ -1,3 +1,3 @@
 example : example.c
-	gcc example.c -o example -ldrmaa -ldrmaa_base
+	gcc example.c -o example -ldrmaa -L/opt/drmaa/torque/lib  -I/opt/drmaa/torque/include
       