Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/Charts.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/Charts.properties	(revision 22)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/Charts.properties	(revision 51)
@@ -33,2 +33,4 @@
 Aggregate=Sumaryczny
 GanntChartTitle=Wykres alokacji zadaÅ dla Grid Scheduling Simulator
+Energy=ZuÅŒycie energii
+ToPNG=Zapisz jako PNG
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/Charts.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/Charts.properties	(revision 22)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/Charts.properties	(revision 51)
@@ -33,2 +33,4 @@
 Aggregate=Aggregated
 GanntChartTitle=Task Allocation Chart for Grid Scheduling Simulator
+Energy=Energy usage
+ToPNG=Save as PNG
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml	(revision 50)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml	(revision 51)
@@ -365,5 +365,5 @@
 	<mx:VBox width="100%" height="100%">
 		<mx:HBox>
-			<mx:Button label="PNG" click="saveAsPNG();"/>
+			<mx:Button label="{resourceManager.getString('Charts', 'ToPNG')}" click="saveAsPNG();"/>
 		</mx:HBox>
 		<mx:VBox width="100%" height="100%" verticalGap="1" id="fullChart">
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 47)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 51)
@@ -256,5 +256,5 @@
 			<mx:ComboBox dataProvider="{chartTypeAC}" id="chartTypeComboBox" change="onServerComboChange(event)"/>
 			<mx:Button label="{resourceManager.getString('Charts', 'Clone')}" click="cloneChart()"/>
-			<mx:Button label="PNG" click="saveAsPNG();"/>
+			<mx:Button label="{resourceManager.getString('Charts', 'ToPNG')}" click="saveAsPNG();"/>
 		</mx:HBox>
 		<mx:VBox width="100%" height="100%" verticalGap="1" id="fullChart">
@@ -291,5 +291,5 @@
 				            	maximumLabelPrecision="1" 
 				            	autoAdjust="false" 
-				            	title="{resourceManager.getString('Charts', 'CPU')}"
+				            	title="{(chartTypeComboBox.selectedItem.type == 'allocation' ? resourceManager.getString('Charts', 'CPU') : resourceManager.getString('Charts', 'Energy'))}"
 				            />
 				        </mx:verticalAxis>
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ExperimentComparisonChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ExperimentComparisonChart.mxml	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ExperimentComparisonChart.mxml	(revision 51)
@@ -265,56 +265,65 @@
 	<mx:VBox width="100%" height="100%">
 		<mx:Canvas  width="100%">
-			<mx:HBox width="100%" id="configPanel" includeInLayout="{configPanel.visible}">
-				<mx:VBox width="200">
-					<mx:Label text="{resourceManager.getString('Charts', 'AvailableExperiments')}" width="100%" />
-					<mx:List id="availableList" dragEnabled="true" dragMoveEnabled="true" width="100%" />
-				</mx:VBox>
-				<mx:VBox width="200">
-					<mx:Label text="{resourceManager.getString('Charts', 'IncludedExperiments')}" width="100%" />
-					<mx:List dataProvider="{experiments}" id="expList" dropEnabled="true" width="100%" />
-					<mx:Button label="Remove item" click="removeItem(expList.selectedIndex)"/>
-				</mx:VBox>
-				<mx:VBox width="100%">
-					<mx:List id="parameterList" dataProvider="{parameterTypes}" labelField="parameter">
-						<mx:itemRenderer>
-							<fx:Component>
-								<mx:CheckBox selectedField="selected" label="{data.parameter}"
-											 change="onChange(event);">
-									<fx:Script>
-										<![CDATA[
-											private function onChange(evt:Event):void {
-												data.selected = !data.selected;
-											}
-										]]>
-									</fx:Script>
-								</mx:CheckBox>
-							</fx:Component>
-						</mx:itemRenderer>
-					</mx:List>
-				</mx:VBox>
-			</mx:HBox>
-			<mx:VBox right="0">
-				<mx:HBox>
-					<mx:Button label="{resourceManager.getString('Charts', 'Collapse')}" click="collapse(false);" visible="{configPanel.visible}" includeInLayout="{configPanel.visible}"/>
-					<mx:Button label="{resourceManager.getString('Charts', 'UnCollapse')}" click="collapse(true);" visible="{!configPanel.visible}" includeInLayout="{!configPanel.visible}"/>
-					<mx:Button label="PNG" click="saveAsPNG();"/>
-				</mx:HBox>
-				<mx:VBox visible="{configPanel.visible}" includeInLayout="{configPanel.visible}">
-					<mx:HBox>
-						<mx:Label text="{resourceManager.getString('Charts', 'XAxisParameterLabel')}"/>					
-						<mx:ComboBox dataProvider="{xAxisTypeAC}" id="xAxisTypeComboBox"/>	
+			<s:Group width="100%">
+				<s:Rect width="100%" height="100%">
+					<s:stroke>
+						<s:SolidColorStroke color="0x999999" weight="1"/>
+					</s:stroke>
+				</s:Rect>
+				<mx:Canvas  width="100%">
+					<mx:HBox width="100%" id="configPanel" includeInLayout="{configPanel.visible}">
+						<mx:VBox width="200">
+							<mx:Label text="{resourceManager.getString('Charts', 'AvailableExperiments')}" width="100%" />
+							<mx:List id="availableList" dragEnabled="true" dragMoveEnabled="true" width="100%" />
+						</mx:VBox>
+						<mx:VBox width="200">
+							<mx:Label text="{resourceManager.getString('Charts', 'IncludedExperiments')}" width="100%" />
+							<mx:List dataProvider="{experiments}" id="expList" dropEnabled="true" width="100%" />
+							<mx:Button label="Remove item" click="removeItem(expList.selectedIndex)"/>
+						</mx:VBox>
+						<mx:VBox width="100%">
+							<mx:List id="parameterList" dataProvider="{parameterTypes}" labelField="parameter">
+								<mx:itemRenderer>
+									<fx:Component>
+										<mx:CheckBox selectedField="selected" label="{data.parameter}"
+													 change="onChange(event);">
+											<fx:Script>
+												<![CDATA[
+													private function onChange(evt:Event):void {
+														data.selected = !data.selected;
+													}
+												]]>
+											</fx:Script>
+										</mx:CheckBox>
+									</fx:Component>
+								</mx:itemRenderer>
+							</mx:List>
+						</mx:VBox>
 					</mx:HBox>
-					<mx:HBox visible="{xAxisTypeComboBox.selectedItem.type == 'experiment'}"
-							 includeInLayout="{xAxisTypeComboBox.selectedItem.type == 'experiment'}">
-						<mx:Label text="{resourceManager.getString('Charts', 'ChartTypeLabel')}"/>
-						<mx:ComboBox dataProvider="{chartTypeAC}" id="chartTypeComboBox"/>
+					<mx:VBox right="0">
+						<mx:VBox visible="{configPanel.visible}" includeInLayout="{configPanel.visible}">
+							<mx:HBox>
+								<mx:Label text="{resourceManager.getString('Charts', 'XAxisParameterLabel')}"/>					
+								<mx:ComboBox dataProvider="{xAxisTypeAC}" id="xAxisTypeComboBox"/>	
+							</mx:HBox>
+							<mx:HBox visible="{xAxisTypeComboBox.selectedItem.type == 'experiment'}"
+									 includeInLayout="{xAxisTypeComboBox.selectedItem.type == 'experiment'}">
+								<mx:Label text="{resourceManager.getString('Charts', 'ChartTypeLabel')}"/>
+								<mx:ComboBox dataProvider="{chartTypeAC}" id="chartTypeComboBox"/>
+							</mx:HBox>
+							<mx:HBox>
+								<mx:Label text="{resourceManager.getString('Charts', 'CharacteristicType')}"/>
+								<mx:ComboBox dataProvider="{metricTypeAC}" id="metricTypeComboBox"/>	
+							</mx:HBox>
+							<mx:Button label="{resourceManager.getString('Charts', 'Plot')}" click="plot();"/>
+						</mx:VBox>
+					</mx:VBox>
+					<mx:HBox bottom="0" right="0">
+						<mx:Button label="{resourceManager.getString('Charts', 'ToPNG')}" click="saveAsPNG();"/>
+						<mx:Button label="{resourceManager.getString('Charts', 'Collapse')}" click="collapse(false);" visible="{configPanel.visible}" includeInLayout="{configPanel.visible}"/>
+						<mx:Button label="{resourceManager.getString('Charts', 'UnCollapse')}" click="collapse(true);" visible="{!configPanel.visible}" includeInLayout="{!configPanel.visible}"/>
 					</mx:HBox>
-					<mx:HBox>
-						<mx:Label text="{resourceManager.getString('Charts', 'CharacteristicType')}"/>
-						<mx:ComboBox dataProvider="{metricTypeAC}" id="metricTypeComboBox"/>	
-					</mx:HBox>
-					<mx:Button label="{resourceManager.getString('Charts', 'Plot')}" click="plot();"/>
-				</mx:VBox>
-			</mx:VBox>
+				</mx:Canvas>
+			</s:Group>
 		</mx:Canvas>
 		<mx:Canvas width="100%" height="100%" id="chartCanvas">