Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ArchiveViewer.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ArchiveViewer.properties	(revision 61)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ArchiveViewer.properties	(revision 63)
@@ -23,2 +23,3 @@
 RunAgain=Uruchom ponownie
 WithSelected=Zaznaczone eksperymenty
+ExperimentsAddedMessage=Dodano zaznaczone eksperymenty do Edytora EksperymentÃ³w, moÅŒna je ponownie uruchomiÄ z poziomu tego edytora.
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties	(revision 46)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties	(revision 63)
@@ -144,2 +144,4 @@
 dzaj plikami
 Close=Zamknij
+
+SaveTooltip=Zapisz zmiany dokonane w eksperymencie
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ArchiveViewer.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ArchiveViewer.properties	(revision 61)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ArchiveViewer.properties	(revision 63)
@@ -22,2 +22,3 @@
 RunAgain=Run again
 WithSelected=Selected experiments
+ExperimentsAddedMessage=Selected experiments have been added to Experiment Editor and can be runned again.
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties	(revision 46)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties	(revision 63)
@@ -125,2 +125,4 @@
 FileManager=Manage files
 Close=Close
+
+SaveTooltip=Save changes made to the experiment
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/ExperimentPropertiesPanel.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/ExperimentPropertiesPanel.mxml	(revision 57)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/ExperimentPropertiesPanel.mxml	(revision 63)
@@ -18,4 +18,5 @@
 			import mx.events.ListEvent;
 			
+			[Bindable]
 			private var editedExperiment : ExperimentProperties;
 			
@@ -276,4 +277,17 @@
 				}
 				workloadMissingImage.visible = true;
+			}
+			
+			protected function cancelExperiment() : void
+			{
+				editedExperiment = null;
+				experimentName.text = "";
+				experimentRuns.value = 1;
+				localGridPlugin.selectedIndex = 0;
+				gridSchedulingPlugin.selectedIndex = 0;
+				executionTimeEstimationPlugin.selectedIndex = 0;
+				workloadFile.text = "";
+				networkTopologyFile.text = "";
+				resourceDescriptionFile.text = "";
 			}
 
@@ -374,5 +388,5 @@
 					<mx:Spacer width="100%"/>
 					<mx:CheckBox id="workloadSelectedCB" label="{resourceManager.getString('ExperimentEditor', 'UseSelectedFiles')}" height="16"
-								 enabled="{!topologySelectedCB.selected &amp;&amp; !resourceSelectedCB.selected}"/>
+								 enabled="{editedExperiment == null &amp;&amp; !topologySelectedCB.selected &amp;&amp; !resourceSelectedCB.selected}"/>
 					<!--
 					<mx:Button label="{resourceManager.getString('ExperimentEditor', 'View')}" click="workloadView()" />
@@ -394,5 +408,5 @@
 					<mx:Spacer width="100%"/>
 					<mx:CheckBox id="resourceSelectedCB" label="{resourceManager.getString('ExperimentEditor', 'UseSelectedFiles')}" height="16"
-								 enabled="{!topologySelectedCB.selected &amp;&amp; !workloadSelectedCB.selected}"/>
+								 enabled="{editedExperiment == null &amp;&amp; !topologySelectedCB.selected &amp;&amp; !workloadSelectedCB.selected}"/>
 				</mx:HBox>
 				<mx:HBox>
@@ -413,5 +427,5 @@
 					<mx:Spacer width="100%"/>
 					<mx:CheckBox id="topologySelectedCB" label="{resourceManager.getString('ExperimentEditor', 'UseSelectedFiles')}"
-								 enabled="{topologyCB.selected &amp;&amp; !resourceSelectedCB.selected &amp;&amp; !workloadSelectedCB.selected}" height="16"/>
+								 enabled="{editedExperiment == null &amp;&amp; topologyCB.selected &amp;&amp; !resourceSelectedCB.selected &amp;&amp; !workloadSelectedCB.selected}" height="16"/>
 				</mx:HBox>
 				<mx:HBox>
@@ -426,5 +440,11 @@
 		<mx:HBox width="100%">
 			<mx:Spacer width="50%"/>
-			<mx:Button id="addExperiment" click="createExperiment();" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Add')}"/>
+			<mx:HBox visible="{editedExperiment == null}" includeInLayout="{editedExperiment == null}">
+				<mx:Button id="addExperiment" click="createExperiment();" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Add')}"/>
+			</mx:HBox>
+			<mx:HBox visible="{editedExperiment != null}" includeInLayout="{editedExperiment != null}">
+				<mx:Button id="saveExperiment" click="createExperiment();" toolTip="{resourceManager.getString('ExperimentEditor', 'SaveTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Save')}"/>
+				<mx:Button id="cancelChangesExperiment" click="cancelExperiment();" toolTip="{resourceManager.getString('ExperimentEditor', 'CancelTooltip')}" labelPlacement="bottom" label="{resourceManager.getString('ExperimentEditor', 'Cancel')}"/>
+			</mx:HBox>
 			<mx:Spacer width="50%"/>
 		</mx:HBox>
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/views/ArchiveViewer.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/views/ArchiveViewer.mxml	(revision 62)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/views/ArchiveViewer.mxml	(revision 63)
@@ -75,4 +75,5 @@
 					ExperimentEditor.experiments.addItem(properties);
 				}
+				Alert.show(resourceManager.getString("ArchiveViewer", "ExperimentsAddedMessage"));
 			}
 			
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java	(revision 57)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java	(revision 63)
@@ -330,4 +330,6 @@
 
 		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
+		//avoid updating experiment list in archive when nothing changed
+		model.setExperimentListChanged(false);
 		
 		Connection connection = null;