Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/GSSimStudioModel.as
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/GSSimStudioModel.as	(revision 53)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/GSSimStudioModel.as	(revision 73)
@@ -20,4 +20,6 @@
 		private var tellBlazeToLoadThisClass : ResourceChartModel;
 		private var tellBlazeToLoadThisClassToo : GanntChartModel;
+		
+		public var resourceTimelineList:ArrayCollection; //used to store data loaded via Network Editor
 		
 		/* Hashmap used to load multiple experiments configurations from Archive into Experiment Editor. */
Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml	(revision 71)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml	(revision 73)
@@ -67,5 +67,4 @@
 		public function loadNetwork(event : ResultEvent) : void
 		{
-			Alert.show("network loads");
 			var r : topologyReader = new topologyReader(parentApplication.topologyEditor.objectCanvas, false);
 			r.readFromBinary(parentApplication.gsSimStudioModel.currentExperimentNetworkTopology);
@@ -82,10 +81,7 @@
 			if (parentApplication.experimentModel.experimentConfiguration.hasOwnProperty('networktopologyfilename'))
 			{
-				Alert.show("network exists");
 				parentApplication.addModelUpdatedSingleCallbacks(
 					parentApplication.service.getExperimentNetworkTopology(experiment.PK), loadNetwork);
 			}
-			//Alert.show(parentApplication.experimentModel.experimentConfiguration['name']);
-			//Alert.show(parentApplication.experimentModel);
 		}
 		
Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java	(revision 68)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java	(revision 73)
@@ -326,4 +326,76 @@
 	}
 	
+	/**
+	 * Used to get data for resource chart in network topology editor.
+	 * 
+	 * @param type a string representing the chart type - energy or allocation
+	 * 
+	 * This method is a copy of the method from ResourceChart.
+	 * FIXME: some refactorization could be useful
+	 */
+	@BlazeDsMethod()
+	public ResourceChartModel getResourceTimelineFromDb(String resourceName, Integer expId, String type) {
+
+		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
+		
+		Connection connection = null;
+		try {
+			connection = factory().createDBConnection(dbAddress, dbUser,
+					dbPassword);
+			Timestamp minTimestamp = minTimestampMilis == null ? null
+					: new Timestamp(minTimestampMilis);
+			Timestamp maxTimestamp = maxTimestampMilis == null ? null
+					: new Timestamp(maxTimestampMilis);
+			
+			ResourceDAO resDAO = factory.createResource();
+			Finder resFinder = Finder.getResourceFinder(expId, resourceName, null);
+			List<Resource> resList = resDAO.find(resFinder);
+			if (resList.size() > 0)
+			{
+				Resource res = resList.get(0);
+				switch (type)
+				{
+					case 'energy':
+					{
+						ResourceAllTimelineDAO resourceDAO = factory
+						.createResourceEnTimeline();
+	
+						Finder finder = Finder.getResourceAllocationTimelineFinder(res.getPK(), minTimestamp, maxTimestamp);
+						List<ResourceEnTimeline> list = resourceDAO.find(finder);
+			
+						model.setResourceTimelineList(list);
+						break;
+					}
+					case 'allocation':
+					{
+						ResourceAllTimelineDAO resourceDAO = factory
+						.createResourceAllTimeline();
+	
+						Finder finder = Finder.getResourceAllocationTimelineFinder(res.getPK(), minTimestamp, maxTimestamp);
+						List<ResourceAllTimeline> list = resourceDAO.find(finder);
+			
+						model.setResourceTimelineList(list);
+						break;
+					}
+				}
+			}
+
+		} catch (SQLException e) {
+			setSqlError("Resources allocation timeline", model, e);
+		} catch (InstantiationException e) {
+			setDbConnectionError(model, e);		
+		} catch (IllegalAccessException e) {
+			setDbConnectionError(model, e);	
+		} catch (ClassNotFoundException e) {
+			setDbConnectionError(model, e);	
+		} catch (Exception e) {
+			setError("Unexpected error occured", model, e);	
+		} finally {
+			closeConnection(connection, model);
+		}
+
+		return model;
+	}
+	
 	@BlazeDsMethod()
 	public GSSimStudioModel getExperimentConfiguration(List experiments) {
Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudioModel.java
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudioModel.java	(revision 53)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudioModel.java	(revision 73)
@@ -39,4 +39,15 @@
     public GSSimStudioModel() {
     }
+    
+    private List resourceTimelineList;
+    
+    public List getResourceTimelineList() {
+		return resourceTimelineList;
+	}
+
+	public void setResourceTimelineList(
+			List resourceTimelineList) {
+		this.resourceTimelineList = resourceTimelineList;
+	}
     
     private HashMap experimentsConfiguration = new HashMap();