Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ResourceEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ResourceEditor.properties	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ResourceEditor.properties	(revision 80)
@@ -19,2 +19,4 @@
 EditResource=Edytuj zasÃ³b
 QueueParameter=Parametr kolejki
+AllocationChart=Alokacje
+EnergyChart=ZuÅŒycie energii
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ResourceEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ResourceEditor.properties	(revision 15)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ResourceEditor.properties	(revision 80)
@@ -18,2 +18,4 @@
 EditResource=Edit resource
 QueueParameter=Queue parameter
+AllocationChart=Allocations
+EnergyChart=Energy usage
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/StaticResourceChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/StaticResourceChart.mxml	(revision 79)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/StaticResourceChart.mxml	(revision 80)
@@ -41,4 +41,6 @@
 			[Bindable]
 			public var resName : String;
+			[Bindable]
+			public var type : String = "allocation";
 			
 			[Bindable]
@@ -151,5 +153,9 @@
 			<mx:VBox width="100%" height="100%" verticalGap="1" id="fullChart">
 				<mx:Label text="{resourceManager.getString('Charts', 'ResourceAllocationTitle')}" width="100%" styleName="title"
-						  />
+						  includeInLayout="{type == 'allocation'}"
+						  visible="{type == 'allocation'}"/>
+				<mx:Label text="{resourceManager.getString('Charts', 'ResourceEnergyTitle')}" width="100%" styleName="title"
+						  includeInLayout="{type == 'energy'}"
+						  visible="{type == 'energy'}"/>
 				<mx:Label text="{resourceManager.getString('Charts', 'CreatedFor')} {expName} {resourceManager.getString('Charts', 'Day')} {date}" width="100%" styleName="subtitle"/>
 				<mx:HBox width="100%" height="100%">
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 51)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/ResourceChart.mxml	(revision 80)
@@ -128,4 +128,5 @@
 				static.resName = resourceComboBox.selectedItem.name;
 				static.dataProvider = ObjectUtil.copy(resourceViewer.dataProvider) as ArrayCollection;
+				static.type = chartTypeComboBox.selectedItem.type;
 				ViewsHelper.ArchiveCanvas.windowManager.add(static);
 			}
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/topology/ObjectPropertiesWindow.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/topology/ObjectPropertiesWindow.mxml	(revision 78)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/topology/ObjectPropertiesWindow.mxml	(revision 80)
@@ -104,4 +104,9 @@
 		}
 		
+		public function loadEnergyChart() : void
+		{
+			parentApplication.addModelUpdatedSingleCallbacks(parentApplication.service.getResourceTimelineFromDb(_object.nodeName,parentApplication.experimentModel.experimentConfiguration['pk'],'energy'), createEnergyChart);
+		}
+		
 		protected function createChart(event : ResultEvent)
 		{
@@ -110,4 +115,15 @@
 			static.resName = _object.nodeName;
 			static.dataProvider = ObjectUtil.copy(parentApplication.gsSimStudioModel.resourceTimelineList) as ArrayCollection;
+			ViewsHelper.TopologyCanvas.windowManager.add(static);
+			//ViewsHelper.ArchiveCanvas.windowManager.add(static);
+		}
+		
+		protected function createEnergyChart(event : ResultEvent)
+		{
+			var static : StaticResourceChart = new StaticResourceChart();
+			static.expName = parentApplication.experimentModel.experimentConfiguration['name'];
+			static.resName = _object.nodeName;
+			static.dataProvider = ObjectUtil.copy(parentApplication.gsSimStudioModel.resourceTimelineList) as ArrayCollection;
+			static.type = "energy";
 			ViewsHelper.TopologyCanvas.windowManager.add(static);
 			//ViewsHelper.ArchiveCanvas.windowManager.add(static);
@@ -171,5 +187,6 @@
 		<mx:HBox>
 			<mx:Button id="EditResourceButton" label="{resourceManager.getString('ResourceEditor', 'EditResource')}" click="editFrontend()" />
-			<mx:Button label="KABOOM" click="loadAllocationChart()" />
+			<mx:Button label="{resourceManager.getString('ResourceEditor', 'AllocationChart')}" click="loadAllocationChart()" />
+			<mx:Button label="{resourceManager.getString('ResourceEditor', 'EnergyChart')}" click="loadEnergyChart()" />
 		</mx:HBox>
 		<mx:Button label="{resourceManager.getString('TopologyEditor', 'Close')}" click="close();"/>