Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml	(revision 46)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml	(revision 81)
@@ -11,4 +11,5 @@
 			import flash.events.Event;
 			import flash.net.FileReferenceList;
+			import flash.net.navigateToURL;
 			
 			import gssim.gssimstudio.editor.gssim.editors.experiment.WorkloadFastViewWindow;
@@ -28,5 +29,7 @@
 			import mx.events.CloseEvent;
 			import mx.events.DragEvent;
+			import mx.events.ListEvent;
 			import mx.managers.DragManager;
+			import mx.rpc.events.ResultEvent;
 			
 			import org.vinetoolkit.vine.net.events.VineUploadEvent;
@@ -149,4 +152,15 @@
 				o = ev.target.selectedItem;
 				parentApplication.service.browseResource(o.url, selectedIndex);
+			}
+			
+			private function openFile(event:ResultEvent):void{
+				var downloadRequest:URLRequest = new URLRequest(parentApplication.gsSimStudioModel.openUrl);
+				navigateToURL(downloadRequest, "_blank");
+			}
+
+
+			protected function itemDoubleClickHandler(event:ListEvent):void
+			{
+				parentApplication.addModelUpdatedSingleCallbacks(parentApplication.service.getOpenURL(event.itemRenderer.data.fileUrl), openFile);
 			}
 
@@ -159,5 +173,6 @@
 				<mx:VBox>
 					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'Workload')}"/>
-					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.workloadFileLocationItemList}" rowHeight="35" id="workloadFilesDG" >
+					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.workloadFileLocationItemList}" rowHeight="35" id="workloadFilesDG"
+								 itemDoubleClick="itemDoubleClickHandler(event)">
 						<mx:columns>
 							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
@@ -182,5 +197,6 @@
 					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'ResourceDescription')}"/>
 					<!--<mx:DataGrid dataProvider="{resourceFiles}" rowHeight="35" id="resourceFilesDG" >-->
-					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.resourcesFileLocationItemList}" rowHeight="35" id="resourceFilesDG" >
+					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.resourcesFileLocationItemList}" rowHeight="35" id="resourceFilesDG" 
+								 itemDoubleClick="itemDoubleClickHandler(event)">
 						<mx:columns>
 							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
@@ -204,5 +220,6 @@
 				<mx:VBox>
 					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
-					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.topologiesFileLocationItemList}" rowHeight="35" id="topologyFilesDG" >
+					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.topologiesFileLocationItemList}" rowHeight="35" id="topologyFilesDG" 
+								 itemDoubleClick="itemDoubleClickHandler(event)">
 						<mx:columns>
 							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/GSSimStudioModel.as
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/GSSimStudioModel.as	(revision 73)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/GSSimStudioModel.as	(revision 81)
@@ -22,4 +22,6 @@
 		
 		public var resourceTimelineList:ArrayCollection; //used to store data loaded via Network Editor
+		
+		public var openUrl : String;
 		
 		/* Hashmap used to load multiple experiments configurations from Archive into Experiment Editor. */
Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java	(revision 78)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudio.java	(revision 81)
@@ -133,4 +133,22 @@
     
     @BlazeDsMethod()
+    public GSSimStudioModel getOpenURL(String fileUrl) throws MalformedURLException {
+    	GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
+        FileLocation fileLocation = new FileLocation(fileUrl);
+        ServletContext servletContext = FlexContext.getServletContext();
+        String contentType = servletContext.getMimeType(fileLocation.getFileName().toLowerCase());
+        log.debug("getOpenURL : contentType: " + contentType);
+        String openUrl = null;
+        if (contentType != null) {
+            openUrl = VineFlexUtilClass.getURL(fileLocation, contentType);
+        } else {
+            openUrl = VineFlexUtilClass.getDownloadURL(fileLocation);
+        }
+
+        model.setOpenUrl(openUrl);
+        return model;
+    }
+    
+    @BlazeDsMethod()
 	public GSSimStudioModel uploadAndSubmitExperiment(String destFileName, String fileContent, String grmsURL, String grmsDN, String jobDescription) throws IOException {
 		String expName = destFileName.split("_")[1].split(".properties")[0];
Index: /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudioModel.java
===================================================================
--- /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudioModel.java	(revision 73)
+++ /gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/java/gssim/gssimstudio/flex/app/editor/GSSimStudioModel.java	(revision 81)
@@ -132,4 +132,20 @@
 	/* END OF DB DATA */
 
+	private String openUrl;
+	
+	/**
+	 * @return the grmsDN
+	 */
+	public String getOpenUrl() {
+		return openUrl;
+	}
+
+	/**
+	 * @param grmsDN the grmsDN to set
+	 */
+	public void setOpenUrl(String openUrl) {
+		this.openUrl = openUrl;
+	}
+	
     /**
 	 * @return the grmsDN