Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties	(revision 63)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/pl_PL/ExperimentEditor.properties	(revision 82)
@@ -111,8 +111,8 @@
 ClearFiles=UsuÅ wszystkie pliki ze zbioru roboczego
 Metaname=Grupa eksperymentÃ³w
-Add=Dodaj
-AddTooltip=Dodaj nowy eksperyment dla tych ustawieÅ i zamknij to okno
-Clone=Klonuj
-CloneTooltip=Dodaj nowy eksperyment dla tych ustawieÅ i nie zamykaj tego okna
+Add=+
+AddTooltip=Dodaj plik do zbioru roboczego
+Download=â
+DownloadTooltip=Pobierz plik na dysk
 Cancel=Anuluj
 CancelTooltip=Zamknij to okno
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties	(revision 63)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/locale/en_US/ExperimentEditor.properties	(revision 82)
@@ -95,8 +95,8 @@
 ClearFiles=Clear all files from workspace
 Metaname=Experiments group
-Add=Add
-AddTooltip=Create new experiment with this settings and close this window
-Clone=Clone
-CloneTooltip=Create new experiment with this settings without closing this window
+Add=+
+AddTooltip=Add file to workspace
+Download=â
+DownloadTooltip=Download file to local storage
 Cancel=Cancel
 CancelTooltip=Drop current experiment settings and close this window
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml	(revision 81)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/experiment/FileManager.mxml	(revision 82)
@@ -156,11 +156,12 @@
 			private function openFile(event:ResultEvent):void{
 				var downloadRequest:URLRequest = new URLRequest(parentApplication.gsSimStudioModel.openUrl);
-				navigateToURL(downloadRequest, "_blank");
-			}
-
-
-			protected function itemDoubleClickHandler(event:ListEvent):void
-			{
-				parentApplication.addModelUpdatedSingleCallbacks(parentApplication.service.getOpenURL(event.itemRenderer.data.fileUrl), openFile);
+				var file : FileReference = new FileReference();
+				file.download(downloadRequest);
+				//navigateToURL(downloadRequest, "_blank");
+			}
+			
+			public function itemDownload(grid : DataGrid):void
+			{
+				parentApplication.addModelUpdatedSingleCallbacks(parentApplication.service.getOpenURL(grid.selectedItem.fileUrl), openFile);
 			}
 
@@ -174,5 +175,5 @@
 					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'Workload')}"/>
 					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.workloadFileLocationItemList}" rowHeight="35" id="workloadFilesDG"
-								 itemDoubleClick="itemDoubleClickHandler(event)">
+								 >
 						<mx:columns>
 							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
@@ -181,9 +182,7 @@
 									<mx:Component>
 										<mx:HBox paddingLeft="4">
-											<!--
-											-<mx:Button label="{resourceManager.getString('ExperimentEditor', 'View')}" toolTip="{resourceManager.getString('ExperimentEditor', 'ViewTooltip')}" click="outerDocument.viewWorkload()" height="30" paddingLeft="8"/>
-											-->
 											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Add')}" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" click="outerDocument.addItemToWorkspace(outerDocument.workloadFilesDG, parentApplication.experimentEditor.workspaceWorkloadsFileList)" height="30"/>
 											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeFileItem(outerDocument.workloadFilesDG)" height="30"/>
+											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Download')}" toolTip="{resourceManager.getString('ExperimentEditor', 'DownloadTooltip')}" click="outerDocument.itemDownload(outerDocument.workloadFilesDG)" height="30"/>
 										</mx:HBox>
 									</mx:Component>
@@ -198,5 +197,5 @@
 					<!--<mx:DataGrid dataProvider="{resourceFiles}" rowHeight="35" id="resourceFilesDG" >-->
 					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.resourcesFileLocationItemList}" rowHeight="35" id="resourceFilesDG" 
-								 itemDoubleClick="itemDoubleClickHandler(event)">
+								 >
 						<mx:columns>
 							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
@@ -205,9 +204,7 @@
 									<mx:Component>
 										<mx:HBox paddingLeft="4">
-											<!--
-											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Load')}" toolTip="{resourceManager.getString('ExperimentEditor', 'LoadTooltip')}" click="outerDocument.loadResources()" height="30" paddingLeft="8"/>
-											-->
 											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Add')}" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" click="outerDocument.addItemToWorkspace(outerDocument.resourceFilesDG, parentApplication.experimentEditor.workspaceResourcesFileList)" height="30"/>
 											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeFileItem(outerDocument.resourceFilesDG)" height="30"/>
+											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Download')}" toolTip="{resourceManager.getString('ExperimentEditor', 'DownloadTooltip')}" click="outerDocument.itemDownload(outerDocument.resourceFilesDG)" height="30"/>
 										</mx:HBox>
 									</mx:Component>
@@ -221,5 +218,5 @@
 					<mx:Label text="{resourceManager.getString('ExperimentEditor', 'NetworkTopology')}"/>
 					<mx:DataGrid dataProvider="{parentApplication.gsSimStudioModel.topologiesFileLocationItemList}" rowHeight="35" id="topologyFilesDG" 
-								 itemDoubleClick="itemDoubleClickHandler(event)">
+								 >
 						<mx:columns>
 							<mx:DataGridColumn dataField="fileName" headerText="Name"/>
@@ -228,9 +225,7 @@
 									<mx:Component>
 										<mx:HBox paddingLeft="4">
-											<!--
-											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Load')}" toolTip="{resourceManager.getString('ExperimentEditor', 'LoadTooltip')}" click="outerDocument.loadTopology()" height="30" paddingLeft="8"/>
-											-->
 											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Add')}" toolTip="{resourceManager.getString('ExperimentEditor', 'AddTooltip')}" click="outerDocument.addItemToWorkspace(outerDocument.topologyFilesDG, parentApplication.experimentEditor.workspaceTopologiesFileList)" height="30"/>
 											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Remove')}" toolTip="{resourceManager.getString('ExperimentEditor', 'RemoveTooltip')}" click="outerDocument.removeFileItem(outerDocument.topologyFilesDG)" height="30"/>
+											<mx:Button label="{resourceManager.getString('ExperimentEditor', 'Download')}" toolTip="{resourceManager.getString('ExperimentEditor', 'DownloadTooltip')}" click="outerDocument.itemDownload(outerDocument.topologyFilesDG)" height="30"/>
 										</mx:HBox>
 									</mx:Component>